﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.31
@EndOfDesignText@
#DesignerProperty: Key: BackgroundColor, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFF000000, Description: Background color

#Event: Click

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private Background As B4XView
	Private IconLabel As B4XView
	
	Public ShadowColor As Int 
	Public DrawShadow As Boolean = True
	Private ShadowSize As Int = 2dip
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	Background = xui.CreatePanel("Background")
	Background.Color = xui.Color_Black
	ShadowColor = xui.Color_DarkGray
	
	IconLabel = MDUtils.createLabel
	IconLabel.Font = xui.CreateMaterialIcons(28)
	IconLabel.SetTextAlignment("CENTER","CENTER")
	IconLabel.TextColor = xui.Color_White
	IconLabel.Text = Chr(0xE145)
	
	#if b4a
	ShadowSize = 4dip
	#End If
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Background.Color = xui.PaintOrColorToColor(Props.Get("BackgroundColor"))
	
	Dim XLBL As B4XView = Lbl
	IconLabel.TextColor = XLBL.TextColor
	IconLabel.Font = XLBL.Font
	IconLabel.Text = XLBL.Text
End Sub

'When creating the View at runtime, dont forget to call resize when the Parent resizes.
Public Sub RuntimeCreateView (Base As B4XView)
	mBase = Base
	
	DrawView
End Sub

Public Sub Resize
	DrawView
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
 	DrawView
End Sub

Private Sub DrawView
	mBase.RemoveAllViews
	'mBase.SetColorAndBorder(mBase.Color,0,0,mBase.Width/2)
	mBase.AddView(Background,0,0,mBase.Width,mBase.Width)
	Background.SetColorAndBorder(Background.Color,0,0,Background.Width/2)
	Background.RemoveAllViews
	Background.AddView(IconLabel,0,0,Background.Width,Background.Height)
	IconLabel.SetColorAndBorder(xui.Color_Transparent,0,0,IconLabel.Width/2)
	
	If DrawShadow Then MDUtils.setShadow(mBase,ShadowColor,ShadowSize,ShadowSize,4)
End Sub

Private Sub Background_Click
	CallSub(mCallBack,mEventName & "_Click")
End Sub

Public Sub setColor(Color As Int)
	Background.Color = Color
End Sub

Public Sub setTextColor(Color As Int)
	IconLabel.TextColor = Color
End Sub

Public Sub setFont(NewFont As B4XFont)
	IconLabel.Font = NewFont
End Sub

Public Sub setIcon(Icon As String)
	IconLabel.Text = Icon
End Sub